import Toast from "components/Toast";
import { commitStore, route } from "stores";

(async () => {

  const commits = (await fetch("build/git.json").then(res => res.json())).map(c => {
    c.date = Date.parse(c.date);
    return c;
  })


  commitStore.set(commits);

  let currentCommit = localStorage.getItem("currentCommit");
  if (!currentCommit) currentCommit = commits[0].id;
  localStorage.setItem("currentCommit", currentCommit);

  let reachedCurrentCommit = false;
  const newCommits = commits.filter(c => {
    if (reachedCurrentCommit) return true;
    if (c.id === currentCommit) {
      reachedCurrentCommit = true;
    }
  });

  if (newCommits.length > 2) {
    if (window.location.hash !== "#changelog") {
      if ((await Toast.ask(`There are <b>${newCommits.length}</b> updates. Do you want to see them?`, ["yes", "no"])) === "yes") {
        route.set("changelog")
      }
    }
  }

})();

export default {};