import store from "./store";

interface addOptions {
  type?: string,
  msg?: string,
  duration?: number,
  options?: string[]
}
function add({ type = "info", msg = "Hey :)", duration = 3000, options = [] }: addOptions) {

  let prom: Promise<boolean | string>;

  const toast: Toast = {
    type,
    msg,
    options,
    duration
  }

  if (type === "confirm" || type === "ask") {
    prom = new Promise((resolve, rej) => {
      toast.resolve = (result = true) => {
        store.update(toasts => toasts.filter(t => t !== toast));
        resolve(result);
      };
      toast.reject = (result = false) => {
        store.update(toasts => toasts.filter(t => t !== toast));
        resolve(result);
      };
    })
  }

  store.update(toasts => [...toasts, toast])

  setTimeout(() => {
    store.update(toasts => toasts.filter(t => t !== toast));
    if (type === "confirm" || type === "ask") {
      toast.reject();
    }
  }, duration);

  return prom;

}

export default {
  info: msg => add({ msg }),
  warn: msg => add({ type: "warn", msg }),
  error: msg => add({ type: "error", msg }),
  confirm: msg => add({ type: "confirm", msg, duration: 10000 }),
  ask: (msg, options) => add({ type: "ask", msg, options, duration: 10000 })
}